Support Questions
Find answers, ask questions, and share your expertise

How to create a custom processor in nifi 1.5.0 ?

Explorer

I have tried to create a nifi custom processor using mvn arhetype : generate and then mvn eclipse:eclipse -DdownloadSources=true to use that in eclipse. when I am importing processor directory and save the project in eclipse I/m getting some errors in pom.xml. bu tin 0.0.2 version not showing such kind of errors.

13 REPLIES 13

The process for creating a custom processor with the archetype has not changed.

Running the command here, but change the versions to the appropriate version like 1.5.0:

https://cwiki.apache.org/confluence/display/NIFI/Maven+Projects+for+Extensions#MavenProjectsforExten...

What errors are you getting?

Explorer

errors like in pom.xml in parent it showing red mark and error message related to goals.

Explorer

[WARNING] The POM for org.apache.nifi:nifi-nar-maven-plugin:jar:1.5.0 is missing, no dependency information available [ERROR] [ERROR] Some problems were encountered while processing the POMs: [ERROR] Unresolveable build extension: Plugin org.apache.nifi:nifi-nar-maven-plugin:1.5.0 or one of its dependencies could not be resolved: Failure to find org.apache.nifi:nifi-nar-maven-plugin:jar:1.5.0 in https://repo.maven.apache.org/maven2 was cached in the local repository, resolution will not be reattempted until the update interval of central has elapsed or updates are forced @ @ [ERROR] The build could not read 1 project -> [Help 1] [ERROR] [ERROR] The project com:alThingCustomProcessor:1.0 (E:\BizRuntime\Projects\v2rNifiProject\AlThingCustomProcessor\alThingCustomProcessor\pom.xml) has 1 error [ERROR] Unresolveable build extension: Plugin org.apache.nifi:nifi-nar-maven-plugin:1.5.0 or one of its dependencies could not be resolved: Failure to find org.apache.nifi:nifi-nar-maven-plugin:jar:1.5.0 in https://repo.maven.apache.org/maven2 was cached in the local repository, resolution will not be reattempted until the update interval of central has elapsed or updates are forced -> [Help 2] [ERROR] [ERROR] To see the full stack trace of the errors, re-run Maven with the -e switch. [ERROR] Re-run Maven using the -X switch to enable full debug logging. [ERROR] [ERROR] For more information about the errors and possible solutions, please read the following articles: [ERROR] [Help 1] http://cwiki.apache.org/confluence/display/MAVEN/ProjectBuildingException [ERROR] [Help 2] http://cwiki.apache.org/confluence/display/MAVEN/PluginManagerException

Explorer

This is the error I got when I was changed version with 1.5.0 in the mentioned plugin, but the fact is it is working when i was used 1.1.0 version

Explorer

I am attaching my pom.xml

Explorer
<?xml version="1.0" encoding="UTF-8"?>
<!--
  Licensed to the Apache Software Foundation (ASF) under one or more
  contributor license agreements. See the NOTICE file distributed with
  this work for additional information regarding copyright ownership.
  The ASF licenses this file to You under the Apache License, Version 2.0
  (the "License"); you may not use this file except in compliance with
  the License. You may obtain a copy of the License at
  http://www.apache.org/licenses/LICENSE-2.0
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>


    <parent>
        <groupId>org.apache.nifi</groupId>
        <artifactId>nifi-nar-bundles</artifactId>
        <version>1.0.0</version>
    </parent>


    <groupId>com</groupId>
    <artifactId>alThingCustomProcessor</artifactId>
    <version>1.0</version>
    <packaging>pom</packaging>


    <modules>
        <module>nifi-demo_sample-processors</module>
        <module>nifi-demo_sample-nar</module>
    </modules>
	<build>
        <plugins>
            <plugin>
                <groupId>org.apache.nifi</groupId>
                <artifactId>nifi-nar-maven-plugin</artifactId>
                <version>1.5.0</version>
                <extensions>true</extensions>
            </plugin>
        </plugins>
    </build>


</project>



Contributor

Also, can you create and build one from the command line without eclipse?

Explorer

Thanks for your response, I will try and then let you know.

Explorer

Can you paste your pom.xml for the error

Explorer
<?xml version="1.0" encoding="UTF-8"?>
<!--
  Licensed to the Apache Software Foundation (ASF) under one or more
  contributor license agreements. See the NOTICE file distributed with
  this work for additional information regarding copyright ownership.
  The ASF licenses this file to You under the Apache License, Version 2.0
  (the "License"); you may not use this file except in compliance with
  the License. You may obtain a copy of the License at
  http://www.apache.org/licenses/LICENSE-2.0
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <parent>
        <groupId>org.apache.nifi</groupId>
        <artifactId>nifi-nar-bundles</artifactId>
        <version>1.0.0</version>
    </parent>
    <groupId>com</groupId>
    <artifactId>alThingCustomProcessor</artifactId>
    <version>1.0</version>
    <packaging>pom</packaging>
    <modules>
        <module>nifi-demo_sample-processors</module>
        <module>nifi-demo_sample-nar</module>
    </modules>
<build>
        <plugins>
            <plugin>
                <groupId>org.apache.nifi</groupId>
                <artifactId>nifi-nar-maven-plugin</artifactId>
                <version>1.5.0</version>
                <extensions>true</extensions>
            </plugin>
        </plugins>
    </build>
</project>

Explorer

@aman I am using the same pom.xml as Bryan mentioned into the given link. If I was using version 1.1.0 then its works fine, but the thing is when i was using 1.5.0 then it is showing error in command prompt the 1.5.0 jar is missing.

Explorer

You can try removing your .m2 directory and then retry the build .. Or manually copy the jar to the directory and then try.

New Contributor

did you solve the issue?, because I am facing a similar one with a different automatically generated pom

Take a Tour of the Community
Don't have an account?
Your experience may be limited. Sign in to explore more.